; Equates for 8259 programming

.xcref IRQ_REC,$IRQ0,$IRQ1,$IRQ2,$IRQ3,$IRQ4,$IRQ5,$IRQ6,$IRQ7
IRQ_REC  record  $IRQ7:1,$IRQ6:1,$IRQ5:1,$IRQ4:1,$IRQ3:1,$IRQ2:1,$IRQ1:1,$IRQ0:1

.xcref @EOI,@EOI0,@EOI1,@EOI2,@EOI3,@EOI4,@EOI5,@EOI6,@EOI7
@EOI	 equ	 20h		; Non-specific End-of-interrupt command to 8259
@EOI0	 equ	 60h+$IRQ0	; Specific EOI for IRQ0
@EOI1	 equ	 60h+$IRQ1	;		   IRQ1
@EOI2	 equ	 60h+$IRQ2	;		   IRQ2
@EOI3	 equ	 60h+$IRQ3	;		   IRQ3
@EOI4	 equ	 60h+$IRQ4	;		   IRQ4
@EOI5	 equ	 60h+$IRQ5	;		   IRQ5
@EOI6	 equ	 60h+$IRQ6	;		   IRQ6
@EOI7	 equ	 60h+$IRQ7	;		   IRQ7

.xcref @ICR,@IMR
@ICR	 equ	 20h		; 8259 port for Interrupt Control Register
@IMR	 equ	 21h		;		Interrupt Mask Register

.xcref @GETIRR,@GETISR
@GETIRR  equ	 0Ah		; Code to request IRR from ICR
@GETISR  equ	 0Bh		;		  ISR

