CODE	segment
	assume	cs:CODE
	org	100h		; COM file origin
ENTRY:	jmp	INIT		; go to install TSR
OLDINT16_VEC dd  ?              ; Save area for old INT 16h handler

INT16    proc    far
         assume  ds:nothing,es:nothing
         pushf                  ; Save flags
         sti                    ; Allow interrupts
         cmp     ah,01h         ; Check for functions 00h-01h
         ja      INT16_ORIG     ; Too big for us
         or      ah,10h         ; Convert to extended functions
INT16_ORIG:
         popf                   ; Restore flags
         jmp     OLDINT16_VEC   ; Continue on
INT16    endp                   ; End INT16 procedure

INIT	proc
	assume	ds:CODE
	mov	ax,3516h	;get int 16h vector
	int	21h
	mov	word ptr OLDINT16_VEC,bx	;save it
	mov	word ptr OLDINT16_VEC+2,es
	mov	ax,2516h	;repoint it
	mov	dx,offset INT16
	int	21h
	mov	dx,offset INIT	;point to end of code
	int	27h		;bye now
INIT	endp
CODE	ends
	end	ENTRY

